routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
//Route group: a groupon belüli összes routra igaz lesz.
//Groupon belül minden Controllert a Controllers/Admin-namespace alatt fog keresni.


use App\Http\Controllers\Admin\NotesController;

Route::middleware('customer_auth')->group(function () {
  Route::get('/ugyfelek', 'CustomersController@index')->name('customers.index');
  Route::delete('/kilepes', 'CustomerAuthController@destroy')->name('login.destroy');

  Route::get('jegyzeteim', 'NotesController@ownNotes')->name('notes.ownNotes');

  Route::delete('jegyzeteim/torles/{noteId}', 'NotesController@destroy')->name('notes.destroy');

  Route::get('/jegyzetek/uj-jegyzet', 'NotesController@create')->name('notes.create');
  Route::post('/jegyzetek/uj-jegyzet', 'NotesController@store')->name('notes.store');

  Route::get('/jegyzetek/{noteId}/modositas', 'NotesController@edit')->name('notes.edit');
  Route::put('/jegyzetek/{noteId}/modositas', 'NotesController@update')->name('notes.update');

  //a jegyzetek/ routok közül legalulra kerül, mert különben a jegyzetek/uj-jegyzet esetén az "uj-jegyzet" részt {customerId}nak gondolva ebbe futna bele.

  Route::post('/jegyzetek/{noteId}/hozzaszolas', 'CommentsController@store')->name('comments.store');
  Route::get('/stat/{type?}','StatController@index')->name('stat');
});

Route::get('/jegyzetek/{customerId?}', 'NotesController@index')->name('notes.index');
Route::get('/jegyzet/{noteId}', 'NotesController@show')->name('notes.show');

/*
Route::get('/', 'PagesController@index')->name('index');
*/
Route::get('/', function (){
    return view('frontend.auth.create');
})->name('index');

//create, store
Route::get('/regisztracio', 'CustomersController@create')->name('customers.create');
Route::post('/regisztracio', 'CustomersController@store')->name('customers.store');


//edit, update
Route::get('/ugyfel/{customerId}/modositas', 'CustomersController@edit')->name('customers.edit');
Route::put('/ugyfel/{customerId}/modositas', 'CustomersController@update')->name('customers.update');

Route::delete('ugyfel/{customerId}/torles', 'CustomersController@destroy')->name('customers.destroy');

Route::get('/ugyfel/{id}', 'CustomersController@show')->name('customers.show');


Route::get('/belepes', 'CustomerAuthController@create')->name('login.create');

Route::post('/belepes', 'CustomerAuthController@store')->name('login.store');


//  Route::post('/login', 'Auth\LoginController@login')->name('login.store');
//Route::post('/belepes', 'CustomerAuthController@store')->name('login.store');

Route::get('/customer', 'CustomersController@newCustomer')->name('customers.newCustomer');

Route::namespace('Admin')->prefix('admin')->name('admin.')->group(function () { //
  //innentől pedig a Controllers/Admin/Auth-ban
  Route::namespace('Auth')->group(function () {
    Route::get('/belepes', 'LoginController@showLoginForm')->name('login.create');
    Route::get('/kilepes', 'LoginController@logout')->name('logout');
    Route::post('/belepes', 'LoginController@login')->name('login.store');
  });

  Route::middleware('admin_auth')->group(function () {
    Route::get('/', 'DashboardController@index')->name('dashboard');
    Route::prefix('customer')->name('customer.')->group(function () {
        //Route::get('/ajaxData', 'CustomerController@ajaxData')->name('ajaxData');
        Route::resource('','CustomerController')->parameters([''=>'id']);
    });
    Route::resource('note','NotesController');
      //Route::resource(customer','CustomerController')->parameters([''=>'id']);
  });
});

app/Models/Customer.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Carbon\Carbon;

/**
 * App\Models\Customer
 *
 * @property int $id
 * @property string $name
 * @property string $email
 * @property string|null $phone
 * @property string $password
 * @property \Illuminate\Support\Carbon|null $created_at
 * @property \Illuminate\Support\Carbon|null $updated_at
 * @property-read \Illuminate\Database\Eloquent\Collection|\App\Models\Comment[] $comments
 * @property-read int|null $comments_count
 * @property-read mixed $notes_comment_count
 * @property-read \Illuminate\Database\Eloquent\Collection|\App\Models\Note[] $notes
 * @property-read int|null $notes_count
 * @method static \Illuminate\Database\Eloquent\Builder|Customer freshRegister()
 * @method static \Illuminate\Database\Eloquent\Builder|Customer newModelQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|Customer newQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|Customer query()
 * @method static \Illuminate\Database\Eloquent\Builder|Customer search($data)
 * @method static \Illuminate\Database\Eloquent\Builder|Customer whereCreatedAt($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Customer whereEmail($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Customer whereId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Customer whereName($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Customer wherePassword($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Customer wherePhone($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Customer whereUpdatedAt($value)
 * @mixin \Eloquent
 */
class Customer extends Authenticatable
{
    //public $table = 'customers';


    public function lastUpdated()
    {
      return $this->updated_at->format('Y-m-d');
    }

    public function notes()
    {
        //1 a többhöz kapcsolat
      return $this->hasMany(Note::class);
    }

    public function comments()
    {
      return $this->hasMany(Comment::Class);
    }

    public function getNotesCommentCountAttribute()
    {
        $notes=Note::where('customer_id',$this->id)->withCount('comments')->get();
        $sum=0;
        foreach ($notes as $note){
            $sum+=$note->comments_count;
        }
        return $sum;
    }


    public function setAttributes($data)
    {
      $this->name = $data['name'];
      $this->email = $data['email'];

      if(isset($data['password']) && $data['password']) {
        $this->password = \Hash::make($data['password']);
      }
    }

    public function scopeSearch($query, $data)
    {
      if(isset($data['name']) && $data['name']) {   //$search['name']  = Horvath;
        $query->where('name', 'LIKE', '%'.$data['name'].'%');
      }

      if(isset($data['email']) && $data['email']) {   //$search['name']  = Horvath;
        $query->where('email', 'LIKE', '%'.$data['email'].'%');
      }

      if(isset($data['orderby']) && $data['orderby']) {
          $query->orderBy($data['orderby'], $data['order_dir']);
      }
    }

    public function scopeFreshRegister($query)
    {
      //a héten regisztráltak
      $date = Carbon::now()->subWeek()->format('Y-m-d');
      $query->where('created_at', '>', $date);
    }
}

app/Http/Controllers/Admin/CustomerController.php
<?php


namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Customer;
use Illuminate\Http\Request;
use Yajra\DataTables\DataTables;
use Yajra\DataTables\Html\Builder;

class CustomerController extends Controller
{

    protected $htmlBuilder;

    public function __construct(Builder $htmlBuilder)
    {
        $this->htmlBuilder = $htmlBuilder;
    }

    public function index(Request $request)
    {
        if ($request->ajax()) {
            $query = Customer::select(['id', 'name', 'email', 'created_at', 'updated_at']);;
            return Datatables::of($query)->make(true);
            return Datatables::of(Customer::select(['id', 'name', 'email', 'created_at', 'updated_at']))->make(true);
        }
        return view('admin.customers.index');
    }


    public function ajaxData(Request $request)
    {
        $html = $this->htmlBuilder
            ->addColumn(['data' => 'id', 'name' => 'id', 'title' => 'Id'])
            ->addColumn(['data' => 'name', 'name' => 'name', 'title' => 'Name'])
            ->addColumn(['data' => 'email', 'name' => 'email', 'title' => 'Email'])
            ->addColumn(['data' => 'created_at', 'name' => 'created_at', 'title' => 'Created At'])
            ->addColumn(['data' => 'updated_at', 'name' => 'updated_at', 'title' => 'Updated At']);
        return view('basic', compact('html'));
        $query = Customer::select(['id', 'name', 'email', 'created_at', 'updated_at']);;
        return datatables($query)->make(true);
    }

    public function show($id)
    {
        return "hello $id " . __FUNCTION__;
    }

    public function edit($id)
    {
        $customer = Customer::findOrFail($id);
        return view('admin.customers.editForm')->with('customer', $customer);
    }

    public function update($customerId, Request $request)
    {

        $this->validate($request, [
            'name' => 'required|string|min:5',
            'email' => 'required|email|unique:customers,email,' . $customerId,  //unique kivéve a megadott IDra
            'password' => 'confirmed'   //nem kötelező, de ha meg van adva, a 2jelszónak egyeznie kell
        ]);

        $customer = Customer::findOrFail($customerId);
        $customer->setAttributes($request->all());
        $customer->save();
        //@todo:kiszedni a passwordot a kikuldott adatbol
        return response()->json(['succes' => true, 'data' => ['customer' => $customer->toArray()]]);
    }

    public function destroy($customerId)
    {
        $customer = Customer::findOrFail($customerId);
        $customer->delete();
        return response()->json(['succes' => true]);
    }

}

app/Http/Controllers/CustomersController.php
<?php

namespace App\Http\Controllers;

use App\Models\Customer;
use Illuminate\Http\Request;

class CustomersController extends Controller
{
    public function show($customerId)
    {
        $customer = Customer::find($customerId);

        return view('frontend.customers.show')->with('customer', $customer);
    }

    public function index(Request $request)
    {
        $search = $request->input('search'); //array
        $search['orderby'] = $request->input('orderby');
        $search['order_dir'] = $request->input('order_dir');

        $customers = Customer::search($search)->get();

        return view('frontend.customers.index')
            ->with('customers', $customers);
    }

    public function create()
    {
        $customer = new Customer;

        return view('frontend.customers.create')->with('customer', $customer);
    }

    public function store(Request $request)
    {
        $this->validate($request, [
            'name' => 'required',
            'email' => 'required|email|unique:customers,email',
            'password' => 'required|confirmed',
            'terms' => 'accepted'
        ]);

        $customer = new Customer;
        $customer->setAttributes($request->all());
        $customer->save();

        session()->flash('message', 'Köszöjük a regisztrációt');
        return redirect()->back();
    }

    public function edit($customerId)
    {
        $customer = Customer::findOrFail($customerId);

        return view('frontend.customers.edit')->with('customer', $customer);
    }

    public function update(Request $request, $customerId)
    {
        $this->validate($request, [
            'name' => 'required',
            'email' => 'required|email|unique:customers,email,' . $customerId,  //unique kivéve a megadott IDra
            'password' => 'confirmed'   //nem kötelező, de ha meg van adva, a 2jelszónak egyeznie kell
        ]);

        $customer = Customer::findOrFail($customerId);
        $customer->setAttributes($request->all());

        $customer->save();

        session()->flash('message', 'Az adatok módosultak');

        return redirect()->route('customers.index');
    }

    public function destroy($customerId)
    {
        $customer = Customer::findOrFail($customerId);
        $customer->delete();
        return response()->json(['message' => 'Az ügyfél törölve']);
    }

}

resources/views/admin/customers/editForm.blade.php
<div class="card card-primary">
    <div class="card-header">
        <h3 class="card-title">Ügyfél Adatok</h3>
    </div>
    <!-- form start -->
    <form class="editorForm" action="{{route('admin.customer.update',$customer->id)}}" method="POST">
        @csrf
        <input type="hidden" name="_method" value="PUT">
        <div class="card-body">
            <div class="form-group">
                <label for="inputName">Email cím</label>
                <input type="text" class="form-control" id="inputName" placeholder="Enter name" name="name"
                       value="{{$customer->name}}">
            </div>
            <div class="form-group">
                <label for="inputEmail1">Email cím</label>
                <input type="email" class="form-control" id="inputEmail1" placeholder="Enter email" name="email"
                       value="{{$customer->email}}">
            </div>
            <div class="form-group">
                <label for="inputPassword1">Password</label>
                <input type="password" class="form-control" id="inputPassword1" placeholder="Password" name="password">
            </div>
            <div class="form-group">
                <label for="inputPassword2">Re Password</label>
                <input type="password" class="form-control" id="inputPassword2" placeholder="Password"
                       name="password_confirmation">
            </div>
            {{--  <div class="form-check">
                  <input type="checkbox" class="form-check-input" id="Check1">
                  <label class="form-check-label" for="Check1">Check me out</label>
              </div>--}}
        </div>
        <!-- /.card-body -->

        <div class="card-footer">
            <button type="submit" class="btn btn-primary btnSubmit">Submit</button>
        </div>
    </form>
    <script>

        window.callbackAction = function (data) {
            console.log('callbackAction');
            console.log(data);
        }
        window.errorCallbackAction = function (data) {
            console.log('errorCallbackAction');
            console.log(data);
        }

        window.ajaxErrorFieldHandler = function (errors, container) {
            let toastBodyHtml = '';
            $.each(errors, function (index, value) {
                toastBodyHtml += '<div>' + value + '<div>';
            });
            Toast.fire({
                icon: 'error',
                html: toastBodyHtml
            });
        }

        $('.editorForm .btnSubmit').click(function (event) {
            var form = $('.editorForm .btnSubmit').closest('form');
            var ajaxDataForm = form.serializeArray();
            //ajaxDataForm.push({name:'callback',value:'callbackAction'});
            //ajaxDataForm.push({name:'errorCallback',value:'errorCallbackAction'});
            $.ajax({
                url: form.attr('action'),
                type: 'PUT',
                headers: {
                    'X-CSRF-TOKEN': $('input[name="_token"]').val()
                },
                data: ajaxDataForm,
                success: function (data) {
                    $(modalId).modal('hide');
                    dTable.ajax.reload(null, false);
                    Toast.fire({
                        icon: 'success',
                        html: 'Sikeres adatmodositas'
                    });
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    if (xhr.responseJSON.errors) {
                        ajaxErrorFieldHandler(xhr.responseJSON.errors);
                    }
                },
            });
            event.preventDefault();
        });


    </script>
</div>

resources/views/admin/customers/index.blade.php
@extends('admin.layout.admin-layout')
@section('content')

    <div class="content-wrapper">
        <!-- Content Header (Page header) -->
        <section class="content-header">

{{--
            <!-- Button trigger modal -->
            <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#ModalForm">
                Launch demo modal
            </button>
--}}

            <!-- Modal -->
            <div class="modal fade" id="ModalForm" tabindex="-1" role="dialog" aria-labelledby="modalTitle" aria-hidden="true">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header" style="display: none">
                            <h5 class="modal-title" >Modal title</h5>
                            <button type="button" class="close btnClose" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            ...
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary btnCancel" data-dismiss="modal">Close</button>
                            <button type="button" class="btn btn-primary btnSave">Save changes</button>
                        </div>
                    </div>
                </div>
            </div>

            <table class="table" id="dataTableBuilder">
                <thead>
                <tr>
                    <th title="Id"> Id</th>
                    <th title="Name">Name</th>
                    <th title="Email"> Email</th>
                    <th title="Created At">Created At</th>
                    <th title="Updated At"> Updated At</th>
                    <th title="action"> </th>
                    <th title="action"> </th>
                </tr>
                </thead>
            </table>
        </section>
        <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->
    <script>
        let dTable;
        $(document).ready(function() {

            dTable=$("#dataTableBuilder").DataTable({
                language: {
                    url: '//cdn.datatables.net/plug-ins/1.10.24/i18n/Hungarian.json'
                },
                "paging": true,
                //"pagingType": "full_numbers",
                "lengthChange": false,
                "searching": true,
                "ordering": true,
                "info": true,
                "autoWidth": false,
                "responsive": true,
                "serverSide": true,
                "processing": true,
                "ajax": "{{route('admin.customer.index')}}",
                rowId: 'id',
                "columns": [
                    {
                        "data": "id",
                        "name": "id",
                        "title": "Id",
                        "orderable": true,
                        "searchable": true
                    }, {
                        "data": "name",
                        "name": "name",
                        "title": "Name",
                        "orderable": true,
                        "searchable": true
                    }, {
                        "data": "email",
                        "name": "email",
                        "title": "Email",
                        "orderable": true,
                        "searchable": true
                    }, {
                        "data": "created_at",
                        "name": "created_at",
                        "title": "Created At",
                        "orderable": true,
                        "searchable": true
                    }, {
                        "data": "updated_at",
                        "name": "updated_at",
                        "title": "Updated At",
                        "orderable": true,
                        "searchable": true
                    },{
                        data: null,
                        "title": "Action",
                        className: "dt-center ",
                        defaultContent: '<a class="btn btn-xs btn-primary dt-editorBtn editor-edit"><i class="fas fa-pencil-alt"></i> Edit</a>' +
                            '<a class="btn btn-xs btn-danger dt-editorBtn editor-delete"><i class="fas fa-trash"></i> Törlés</a>' +
                            '',
                        orderable: false,
                        "searchable": false
                    },
                ]
            });

        });


        $('#dataTableBuilder').on('click', 'a.editor-edit', function (e) {
            e.preventDefault();
            let ajaxUrl="{{route('admin.customer.edit',':id')}}";
            ajaxUrl=ajaxUrl.replace(':id',dTable.row( $(this).closest('tr') ).id());
            modalForm({bodyAjaxUrl:ajaxUrl});
        } );

        $('#dataTableBuilder').on('click', 'a.editor-delete', function (e) {
            e.preventDefault();
            let ajaxUrl="{{route('admin.customer.destroy',':id')}}";
            ajaxUrl=ajaxUrl.replace(':id',dTable.row( $(this).closest('tr') ).id());
            $.ajax({
                url: ajaxUrl,
                type: 'DELETE',
                headers: {
                    'X-CSRF-TOKEN': '{{csrf_token()}}'
                },
                success: function (data) {
                    dTable.ajax.reload(null,false);
                    Toast.fire({
                        icon: 'info',
                        html: 'Sikeres törlés'
                    });
                },
                error:function (xhr, ajaxOptions, thrownError){
                    if(xhr.responseJSON.errors){
                        ajaxErrorFieldHandler(xhr.responseJSON.errors);
                    };
                },
            });

        });
    </script>
@endsection